#************SIMULATIONS Lois gomtriques tronques*************
# LaUneroulette est divise en 18 secteurs identiques numrot 1  18
# On fait tourner la roue n fois (n>=1) et on note X la variable
# alatoire prenant pour valeurs le rang de la premire apparition du
# numro 9, ou bien 0 si le 9 n'est pas sorti.
# Les algorithmes suivants simulent cette exprience alatoire.
# et gnralisent des modles de simulation.
#-----AlgoHyp290_23()---simulation d'un rang--runif-- nonc
# Modle roulette 18 secteurs
AlgoHyp290_23 <- function(){
  x <- floor(1 + 18 * (runif(1, 0, 1)))
  i <- 1
  while(x != 9 & i <= 20){
    x <- floor(1 + 18 * (runif(1, 0, 1)))
    i <- i + 1
  }
# Affichage du rsultat
  if(i <= 20){
    cat("\nRang du premier 9 =", i, "\n")
  } else {
    cat("\nRang du premier 9 =", 0, "\n")
  }
}

#----------------------------------------------------
#-----AlgoHyp290_23_1()---simulation d'un rang--sample 1
# Modle roulette 18 secteurs
AlgoHyp290_23_1 <- function(){
  x <- sample(1:18, 1)
  i <- 1
  while(x != 9 & i <= 20){
    x <- sample(1:18, 1)
    i <- i + 1
  }
# Affichage du rsultat
  if(i <= 20){
    cat("\nRang du premier 9 =", i, "\n")
  } else {
    cat("\nRang du premier 9 =", 0, "\n")
  }
}

#----------------------------------------------------
#-----AlgoHyp290_23_2()---simulation d'un rang--roulette-sample 1
# Modle roulette 18 secteurs
AlgoHyp290_23_2 <- function(){
  roulette <- 1:18
  x <- sample(roulette, 1)
  i <- 1
  while(x != 9 & i <= 20){
    x <- sample(roulette, 1)
    i <- i + 1
  }
# Affichage du rsultat
  if(i <= 20){
    cat("\nRang du premier 9 =", i, "\n")
  } else {
    cat("\nRang du premier 9 =", 0, "\n")
  }
}

#----------------------------------------------------
#-----AlgoHyp290_23_3()----simulation d'un rang--roulette-sample 20
# Modle roulette 18 secteurs
AlgoHyp290_23_3 <- function(){
  roulette <- 1:18
  x <- sample(roulette, 20, replace = TRUE)
  if(sum(x - 9 == 0) > 0){k <- min(which(x == 9))} else {k <- 0} 
# Affichage du rsultat
  cat("\nRang du premier 9 =", k, "\n")
}

#----------------------------------------------------
#------AlgoHyp290_23_4()----simulation d'un rang--roulette--paramtres..
# Modle roulette nbsecteurs
AlgoHyp290_23_4 <- function(nbparties = 20, nbsect = 18, numero = 9){
  roulette <- 1:nbsect
  x <- sample(roulette, nbparties, replace = TRUE)
  if(sum(x - numero == 0) > 0){k <- min(which(x == numero))}else{k <- 0}
# Affichage du rsultat
  cat("\nRang du premier", numero,"=", k, "\n")
}

#----------------------------------------------------
#--AlgoHyp290_23_5()--simulation de la distribution des rangs--
# Modle roulette nbsecteurs
AlgoHyp290_23_5 <- function(nbparties = 20, nbsect = 18, numero = 9,
                            nbsim = 2000){
  roulette <- 1:nbsect
  seriesim <- NULL
  for(i in 1:nbsim){
    x <- sample(roulette, nbparties, replace = TRUE)
    if(sum(x - numero == 0) > 0){
      seriesim[i] <- min(which(x == numero))
    } else {
      seriesim[i] <- 0
    }
  }
  distsim <- table(seriesim)
# Affichage des rsultats et des graphiques
  cat("\nTableau de distribution du Rang du premier", numero, "\n")
  print(distsim / nbsim)
  barplot(distsim / nbsim)
}

#----------------------------------------------------
#--AlgoHyp290_23_5_1()--simulation de la distribution des rangs--
# Modle roulette nbsecteurs Calculs somme frquences et moyenne simule
AlgoHyp290_23_5_1 <- function(nbparties = 20, nbsect = 18, numero = 9,
                            nbsim = 2000){
  roulette <- 1:nbsect
  seriesim <- NULL
  for(i in 1:nbsim){
    x <- sample(roulette, nbparties, replace = TRUE)
    if(sum(x - numero == 0) > 0){
      seriesim[i] <- min(which(x == numero))
    } else {
      seriesim[i] <- 0
    }
  }
  distfreq <- table(seriesim) / nbsim
  moysim <- sum(distfreq * as.numeric(names(distfreq)))
# Affichage des rsultats et des graphiques
  cat("\nTableau de distribution du Rang du premier", numero, "\n")
  print(distfreq)
  cat("\nMoyenne simule :\n", moysim, "\n\n")
  barplot(distfreq)
}

#----------------------------------------------------
#--AlgoHyp290_23_6()--simulation de la distribution des rangs--
# Modle d'urnes nbboules rouges, nbtotal, tirages avec remise
AlgoHyp290_23_6 <- function(nbtirages = 20, nbrouges = 1, nbtot = 18,
                            nbsim = 2000){
  urne <- rep(c("brouge", "bautre"), c(nbrouges, nbtot - nbrouges))
  seriesim <- NULL
  for(i in 1:nbsim){
    x <- sample(urne, nbtirages, replace = TRUE)
    if(sum(x == "brouge") > 0){
      seriesim[i] <- min(which(x == "brouge"))
    } else {
      seriesim[i] <- 0
    }
  }
  distsim <- table(seriesim)
# Affichage des rsultats et des graphiques
  cat("\nTableau de distribution du rang de la premire rouge\n")
  print(distsim / nbsim)
  barplot(distsim / nbsim)
}

#----------------------------------------------------
#------AlgoHyp290_23_7()----simulation de la distribution des rangs--
# Modle preuves de Bernoulli rptes (independantes) --n, p
AlgoHyp290_23_7 <- function(n = 20, p = 1 / 18, nbsim = 2000){
  deuxalternatives <- c("succes", "echec")
  seriesim <- NULL
  for(i in 1:nbsim){
    x <- sample(deuxalternatives, n, prob = c(p, 1 - p), replace = TRUE)
    if(sum(x == "succes") > 0){
      seriesim[i] <- min(which(x == "succes"))
    } else {
      seriesim[i] <- 0
    }
  }
  distsim <- table(seriesim)
# Affichage des rsultats et des graphiques
  cat("\nTableau de distribution du Rang du premier succs\n")
  print(distsim / nbsim)
  barplot(distsim / nbsim)
}

*************************************************************
#------AlgoHyp290_23_8()----simulation de la distribution des rangs--
# Modle preuves de Bernoulli rptes (independantes) --n, p
# Graphiques des distributions simules et calcules
AlgoHyp290_23_8 <- function(n = 20, p = 1 / 18,
                            nbsim = 2000, echelY = .35){
  ValeursX <- 0:n
  DistGeoTronk <- NULL
  DistGeoTronk[1] <- (1 - p)^n
  DistGeoTronk[2:(n + 1)] <- (1 - p)^((1:n) - 1) * p
  names(DistGeoTronk) <- ValeursX
  deuxalternatives <- c("succes", "echec")
  seriesim <- NULL
  tableauFreq <- rep(0, n + 1)
  names(tableauFreq) <- ValeursX
  for(i in 1:nbsim){
    x <- sample(deuxalternatives, n, prob = c(p, 1 - p), replace = TRUE)
    if(sum(x == "succes") > 0){
      seriesim[i] <- min(which(x == "succes"))
    } else {
      seriesim[i] <- 0
    }
  }
  distsim <- table(seriesim)
  tableauFreq[as.numeric(names(distsim)) + 1] <- distsim / nbsim
# Affichage des rsultats et des graphiques
  cat("Tableau des frquences simules du Rang du premier succs\n")
  print(tableauFreq)
  cat("\nTableau de probabilit du Rang du premier succs\n")
  print(DistGeoTronk)
  plot(ValeursX, tableauFreq, type = "h", xaxp = c(0, n, n),
     ylim = c(0, echelY),ylab = "Frquences",
     xlab = "Rang du premier succs",
     main = "Diagramme en barres et en points GeoTronk")
   points(ValeursX, DistGeoTronk, pch = 21, col = "red", bg = "red")
   legend(x = "topright",
     legend = c("Frquences simules", "Probabilits"),
     bg = "grey90", pch = c(124, 21), pt.cex = c(1, 1),
     col = c("black", "red"), pt.bg = c(NA, "red"))
}

#--------------------------------------------------------------------
#----AlgoHyp290_23_8bis()----simulation de la distribution des rangs--
# Modle preuves de Bernoulli rptes (independantes) --n, p
# Graphiques des distributions simules et Exponentielle de paramtre 1/p
AlgoHyp290_23_8bis <- function(n = 100, p = 1 / 18, nbsim = 2000){
  Esperance <- 1 / p
  ValeursX <- 0:n ; bornes <- seq(-.5, (n + .5), 1)
  DistExpo <- exp(- ValeursX / Esperance) / Esperance
  deuxalternatives <- c("succes", "echec")
  seriesim <- NULL
  for(i in 1:nbsim){
    x <- sample(deuxalternatives, n, prob = c(p, 1 - p), replace = TRUE)
    if(sum(x == "succes") > 0){
      seriesim[i] <- min(which(x == "succes"))
    } else {
      seriesim[i] <- 0
    }
  }
  moyenne <- mean(seriesim)
# Affichage des rsultats et des graphiques
  cat("Moyenne de la srie simule =", moyenne,
    "\nEsprance exponentielle =", Esperance, "\n\n")
  hist(seriesim, breaks = bornes, freq = FALSE,
    xlab = "Rang du premier succs",
    main = "Histogramme de la srie simul et densit exponentielle")
    points(ValeursX, DistExpo, type = "l", col = "red", lwd = 2)
    legend(x = "topright",
      legend = c("Densit simule", "Densit exponentielle"),
      bg = "grey90", pch = c(95, 95 ), pt.cex = c(1, 1.3),
      col = c("black", "red"))
}

#----------------------------------------------------
#------AlgoHyp290_23_9()----simulation de la distribution des rangs--
# Modle preuves de Bernoulli rptes (independantes) --n, p
# Graphiques des distributions simules et calcules
# UTILISATION D'UNE FONCION EXTERNE geotronk2()
geotronk2 = function(k, n, p){
  distribX <- rep(0, n + 1)
  names(distribX) <- 0:n
  distribX[1] <- (1 - p)^n
  distribX[2:(n + 1)] <- (1 - p)^((1:n) - 1) * p
  proba <- distribX[k + 1]
  return(proba)
}
#-----Deux fentres graphiques pour plot-points et barplot-points
AlgoHyp290_23_9 <- function(n = 20, p = 1 / 18,
                            nbsim = 2000, echelY = .35){
  ValeursX <- 0:n
  DistGeoTronk <- geotronk2(ValeursX, n, p)
  deuxalternatives <- c("succes", "echec")
  seriesim <- NULL
  tableauFreq <- rep(0, n + 1)
  names(tableauFreq) <- ValeursX
  for(i in 1:nbsim){
    x <- sample(deuxalternatives, n, prob = c(p, 1 - p), replace = TRUE)
    if(sum(x == "succes") > 0){
      seriesim[i] <- min(which(x == "succes"))
    } else {
      seriesim[i] <- 0
    }
  }
  distsim <- table(seriesim)
  tableauFreq[as.numeric(names(distsim)) + 1] <- distsim / nbsim
# Affichage des rsultats
  cat("Tableau des frquences simules du Rang du premier succs\n")
  print(tableauFreq)
  cat("\nTableau de probabilit du Rang du premier succs\n")
  print(DistGeoTronk)
# On ferme touts les graphiques prcedents
graphics.off()
# Graphiques superposant plot et points dans une nouvelle fentre
#  Affichage des graphiques superposs plot-points
  plot(ValeursX, tableauFreq, type = "h", xaxp = c(0, n, n),
    ylab = "Frquences", xlab = "Rang du premier succs",
    ylim = c(0, echelY), cex.axis = .7,
    main = "Diagramme en barres et en points GeoTronk")
    points(ValeursX, DistGeoTronk, pch = 21, col = "red", bg = "red")
    legend(x = "topright",
      legend = c("Frquences simules", "Probabilits"),
      bg = "grey90", pch = c(124, 21), pt.cex = c(1, 1),
      col = c("black", "red"), pt.bg = c(NA, "red"))
# On ouvre une nouvelle fentre graphique
dev.new()
# Graphiques superposant barplot et points dans cette nouvelle fentre
  barplot(tableauFreq, ylim = c(0, echelY), cex.names = .7, cex.axis = .7,
      ylab = "Frquences", xlab = "Rang du premier succs",
      main = "Diagramme en barres et en points GeoTronk")
    points(barplot(0:n, plot = FALSE), DistGeoTronk,
      pch = 21, col = "red", bg = "red")
    legend(x = "topright",
      legend = c("Frquences simules", "Probabilits"),
      bg = "grey90", pch = c(22, 21), pt.cex = c(1, 1),
      col = c("black", "red"), pt.bg = c("grey", "red"))
}

#--------------------------------------------------------
#------AlgoHyp290_23_10()----simulation de la distribution des rangs--
# Modle preuves de Bernoulli rptes (independantes) --n, p
# Graphiques des distributions simules et calcules
# UTILISATION D'UNE FONCION EXTERNE geotronk2()
geotronk2 = function(k, n, p){
  distribX <- rep(0, n + 1)
  names(distribX) <- 0:n
  distribX[1] <- (1 - p)^n
  distribX[2:(n + 1)] <- (1 - p)^((1:n) - 1) * p
  proba <- distribX[k + 1]
  return(proba)
}
#Une fentre graph. partage en deux pour plot-points et barplot-points
AlgoHyp290_23_10 <- function(n = 20, p = 1 / 18,
                             nbsim = 2000, echelY = .35){
  ValeursX <- 0:n
  DistGeoTronk <- geotronk2(ValeursX, n, p)
  deuxalternatives <- c("succes", "echec")
  seriesim <- NULL
  tableauFreq <- rep(0, n + 1)
  names(tableauFreq) <- ValeursX
  for(i in 1:nbsim){
    x <- sample(deuxalternatives, n, prob = c(p, 1 - p), replace = TRUE)
    if(sum(x == "succes") > 0){
      seriesim[i] <- min(which(x == "succes"))
    } else {
      seriesim[i] <- 0
    }
  }
  distsim <- table(seriesim)
  tableauFreq[as.numeric(names(distsim)) + 1] <- distsim / nbsim
# Affichage des rsultats
  cat("Tableau des frquences simules du Rang du premier succs\n")
  print(tableauFreq)
  cat("\nTableau de probabilit du Rang du premier succs\n")
  print(DistGeoTronk)
# Partage de la fentre graphique en deux paries
  par(mfrow = c(2, 1))
# Graphiques superposant plot et points dans une nouvelle fentre
# Affichage des graph. superposs plot-points dans la partie suprieure
  plot(ValeursX, tableauFreq, type = "h", xaxp = c(0, n, n),
    ylim = c(0, echelY),
    ylab = "Frquences", xlab = "Rang du premier succs", cex.axis = .7,
    main = "Diagramme en barres et en points GeoTronk")
    points(ValeursX, DistGeoTronk, pch = 21, col = "red", bg = "red")
    legend(x = "topright",
      legend = c("Frquences simules", "Probabilits"),
      bg = "grey90", pch = c(124, 21), pt.cex = c(1, 1),
      col = c("black", "red"), pt.bg = c(NA, "red"))
# Affich des graph. superposs barplot-points dans la partie infrieure
  barplot(tableauFreq, ylim = c(0, echelY), cex.names = .7,
    cex.axis = .7, ylab = "Frquences", xlab = "Rang du premier succs",
    main = "Diagramme en barres et en points GeoTronk")
    points(barplot(0:n, plot = FALSE), DistGeoTronk, pch = 21,
      col = "red", bg = "red")
    legend(x = "topright",
      legend = c("Frquences simules", "Probabilits"),
      bg = "grey90", pch = c(22, 21), pt.cex = c(1, 1),
      col = c("black", "red"), pt.bg = c("grey", "red"))
}

#************************************************
# UTILISATION D'UNE FONCION EXTERNE geotronk2()
# Calcul de la somme des probabilits de l'esprance et de la variance
geotronk2 = function(k, n, p){
  distribX <- rep(0, n + 1)
  names(distribX) <- 0:n
  distribX[1] <- (1 - p)^n
  distribX[2:(n + 1)] <- (1 - p)^((1:n) - 1) * p
  proba <- distribX[k + 1]
  return(proba)
}
# Application numrique de l'nonc AlgoHyp290_23
# Somme numrique des probabilits
sum(geotronk2(0:20, 20, 1 / 18))
# Esprance numrique
(somxipi <- sum(0:20 * geotronk2(0:20, 20, 1 / 18)))
# Variance numrique
(somxi2pi <- sum((0:20)^2 * geotronk2(0:20, 20, 1 / 18)))
(vargeotronk <- somxi2pi - somxipi^2)

#-------------------------------------------------
# Application numrique de l'nonc AlgoHyp296_50
# Esprance numrique
(somxipi <- sum(0:50 * geotronk2(0:50, 50, 1 / 5)))
# Variance numrique
(somxi2pi <- sum((0:50)^2 * geotronk2(0:50, 50, 1 / 5)))
(vargeotronk <- somxi2pi - somxipi^2)


